/**
 * vTabs - dynamic, flexible and accessible AngularJS tabs.
 * @version v0.1.1
 * @link http://lukaszwatroba.github.io/v-tabs
 * @author Łukasz Wątroba <l@lukaszwatroba.com>
 * @license MIT License, http://www.opensource.org/licenses/MIT
 */

!function(e){"use strict";function t(e,t){return{restrict:"EA",require:"^vPages",transclude:!0,scope:{},link:function(n,i,a,c,o){function r(){e.addClass(i,t.states.active)}function s(){e.removeClass(i,t.states.active)}o(n.$parent,function(e){i.append(e)}),a.$set("role","tabpanel"),c.addPage(n),n.isActive&&i.addClass(t.states.active),n.$watch("isActive",function(e,t){return e===t?!1:(e?r():s(),void 0)})}}}function n(){return{restrict:"EA",transclude:!0,scope:{activeIndex:"=?active",control:"=?"},controller:i,controllerAs:"pagesCtrl",link:function(t,n,i,a,c){function o(){e.forEach(r,function(e){if(t.control[e])throw new Error("The `"+e+"` method can not be overwritten")})}c(t.$parent,function(e){n.append(e)});var r=["next","previous","activate"];if(e.isDefined(t.activeIndex)&&e.isNumber(t.activeIndex)||(t.activeIndex=0),e.isDefined(t.control)){o();var s=e.extend({},t.internalControl,t.control);t.control=t.internalControl=s}else t.control=t.internalControl}}}function i(t){var n=this;t.pages=[],n.getPageByIndex=function(e){return t.pages[e]},n.getPageIndex=function(e){return t.pages.indexOf(e)},n.addPage=function(e){t.pages.push(e),t.pages.length-1===t.activeIndex&&n.activate(e)},n.next=function(){var e=t.activeIndex+1;e>t.pages.length-1&&(e=0),t.activeIndex=e},n.previous=function(){var e=t.activeIndex-1;0>e&&(e=t.pages.length-1),t.activeIndex=e},n.activate=function(n){n&&(n.isActive||(n.isActive=!0,e.forEach(t.pages,function(e){e!==n&&e.isActive&&(e.isActive=!1)})))},t.$watch("activeIndex",function(e,t){e!==t&&n.activate(n.getPageByIndex(e))}),t.internalControl={next:function(){n.next()},previous:function(){n.previous()},activate:function(e){t.activeIndex=e}}}function a(e,t){return{restrict:"EA",require:"^vTabs",transclude:!0,scope:{disabled:"=ngDisabled"},link:function(n,i,a,c,o){function r(){e.addClass(i,t.states.active),i.attr({"aria-selected":"true",tabindex:"0"})}function s(){e.removeClass(i,t.states.active),i.attr({"aria-selected":"false",tabindex:"-1"})}o(n.$parent,function(e){i.append(e)}),a.$set("role","tab"),c.addTab(n),n.tabsCtrl=c,n.focus=function(){i[0].focus()},n.isActive?(e.addClass(i,t.states.active),i.attr({"aria-selected":"true",tabindex:"0"})):i.attr({"aria-selected":"false",tabindex:"-1"}),i[0].onfocus=function(){n.isFocused=!0},i[0].onblur=function(){n.isFocused=!1},i.on("click",function(){return n.disabled?!1:(n.$apply(function(){c.activate(n)}),void 0)}),i.on("keydown",function(e){return n.disabled?!1:(32===e.keyCode||13===e.keyCode?(n.$apply(function(){c.activate(n)}),e.preventDefault()):39===e.keyCode?(n.$apply(function(){c.focusNext()}),e.preventDefault()):37===e.keyCode&&(n.$apply(function(){c.focusPrevious()}),e.preventDefault()),void 0)}),n.$watch("isActive",function(e,t){return e===t?!1:(e?r():s(),void 0)})}}}function c(){return{restrict:"EA",transclude:!0,scope:{activeIndex:"=?active",control:"=?"},controller:o,controllerAs:"tabsCtrl",link:function(t,n,i,a,c){function o(){e.forEach(r,function(e){if(t.control[e])throw new Error("The `"+e+"` method can not be overwritten")})}c(t.$parent,function(e){n.append(e)});var r=["next","previous","activate"];if(e.isDefined(t.activeIndex)&&e.isNumber(t.activeIndex)||(t.activeIndex=0),e.isDefined(t.control)){o();var s=e.extend({},t.internalControl,t.control);t.control=t.internalControl=s}else t.control=t.internalControl}}}function o(t){var n=this;t.tabs=[],n.getTabByIndex=function(e){return t.tabs[e]},n.getTabIndex=function(e){return t.tabs.indexOf(e)},n.addTab=function(e){t.tabs.push(e);var n=t.tabs.length-1;n===t.activeIndex&&(e.isActive=!0)},n.focusNext=function(){for(var e=t.tabs.length,n=0;e>n;n++){var i=t.tabs[n];if(i.isFocused){var a=n+1;a>t.tabs.length-1&&(a=0);var c=t.tabs[a];c.focus();break}}},n.focusPrevious=function(){for(var e=t.tabs.length,n=0;e>n;n++){var i=t.tabs[n];if(i.isFocused){var a=n-1;0>a&&(a=t.tabs.length-1);var c=t.tabs[a];c.focus();break}}},n.next=function(){var e=t.activeIndex+1;e>t.tabs.length-1&&(e=0),t.activeIndex=e},n.previous=function(){var e=t.activeIndex-1;0>e&&(e=t.tabs.length-1),t.activeIndex=e},n.activate=function(i){i&&(i.isActive||(i.isActive=!0,t.activeIndex=n.getTabIndex(i),e.forEach(t.tabs,function(e){e!==i&&e.isActive&&(e.isActive=!1)})))},t.$watch("activeIndex",function(e,i){if(e!==i){var a=n.getTabByIndex(e);return a.disabled?(t.activeIndex=i,!1):(n.activate(n.getTabByIndex(e)),void 0)}}),t.internalControl={next:function(){n.next()},previous:function(){n.previous()},activate:function(e){t.activeIndex=e}}}e.module("vTabs.config",[]).constant("tabsConfig",{states:{active:"is-active"}}).constant("pagesConfig",{states:{active:"is-active"}}),e.module("vTabs.directives",[]),e.module("vTabs",["vTabs.config","vTabs.directives"]),e.module("vTabs.directives").directive("vPage",t),t.$inject=["$animate","pagesConfig"],e.module("vTabs.directives").directive("vPages",n),i.$inject=["$scope"],e.module("vTabs.directives").directive("vTab",a),a.$inject=["$animate","tabsConfig"],e.module("vTabs.directives").directive("vTabs",c),o.$inject=["$scope"]}(angular);